## dmidiplayer-dmo 1.4.0

=== CMakeLists.txt ===
# Drumstick MIDI File Player Multiplatform Program
# Copyright (C) 2006-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.14)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

project ( dmidiplayer
    VERSION 1.4.0
    LANGUAGES CXX
    DESCRIPTION "Drumstick MIDI File Player Multiplatform Program"
    HOMEPAGE_URL "https://sourceforge.net/p/dmidiplayer/"
)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

option(BUILD_DOCS "Build man pages" ON)
option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)

include(SCMRevision)

find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package (Qt${QT_VERSION_MAJOR} COMPONENTS Gui Widgets PrintSupport LinguistTools REQUIRED)
find_package (Drumstick 2.3 COMPONENTS File RT Widgets REQUIRED)

find_package( PkgConfig )
pkg_check_modules( UCHARDET REQUIRED IMPORTED_TARGET uchardet )

if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    find_package(Qt6 COMPONENTS Core5Compat REQUIRED)
endif()

SET(SOURCES
    channels.cpp
    channels.h
    connections.cpp
    connections.h
    connections.ui
    events.cpp
    events.h
    guiplayer.cpp
    guiplayer.h
    guiplayer.qrc
    guiplayer.ui
    iconutils.cpp
    iconutils.h
    instrumentset.cpp
    instrumentset.h
    lyrics.cpp
    lyrics.h
    pianola.cpp
    pianola.h
    playlist.cpp
    playlist.h
    playlist.ui
    playerabout.cpp
    playerabout.h
    playerabout.ui
    playermain.cpp
    prefsdialog.cpp
    prefsdialog.h
    prefsdialog.ui
    recentfileshelper.cpp
    recentfileshelper.h
    rhythmview.cpp
    rhythmview.h
    seqplayer.cpp
    seqplayer.h
    sequence.cpp
    sequence.h
    settings.cpp
    settings.h
    toolbareditdialog.cpp
    toolbareditdialog.h
    toolbareditdialog.ui
    vumeter.cpp
    vumeter.h
)

if (WIN32)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("#include <Windows.h>
        int main() { EnumWindows([](HWND, LPARAM) -> BOOL { return true; }, 0); return 0; }"
        COMPILER_SUPPORTED)
    if (NOT COMPILER_SUPPORTED)
        message(FATAL_ERROR "Sorry, your compiler is not supported: ${CMAKE_CXX_COMPILER}")
    endif()
    list(APPEND SOURCES winsnap.cpp winsnap.h)
endif()

set ( TRANSLATIONS
   translations/${PROJECT_NAME}_cs.ts
   translations/${PROJECT_NAME}_es.ts
   translations/${PROJECT_NAME}_ru.ts
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_add_translation (QM_FILES ${TRANSLATIONS})
else()
    qt_add_translation (QM_FILES ${TRANSLATIONS})
endif()
add_custom_target (translations ALL DEPENDS ${QM_FILES})
include(TranslationUtils)

if (EMBED_TRANSLATIONS)
    get_target_property(DRUMSTICK_LOCATION Drumstick::Widgets INTERFACE_INCLUDE_DIRECTORIES)
    get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
    file(COPY ${WIDGETS_TRANS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    add_app_translations_resource(APP_RES ${QM_FILES} ${WIDGETS_TRANS})
    add_qt_translations_resource(QT_RES cs es ru)
    list(APPEND SOURCES ${APP_RES} ${QT_RES})
endif()

if (WIN32)
    set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.nsi.in
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.nsi IMMEDIATE @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc.in
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc IMMEDIATE @ONLY)
    set (RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc)
    set (RES_FILE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.res.obj)
    find_program (WINDRES_EXECUTABLE NAMES windres mingw32-windres i686-mingw32-windres)
    if (MINGW)
        exec_program (${WINDRES_EXECUTABLE}
            ARGS "-i ${RC_FILE} -o ${RES_FILE} --include-dir=${CMAKE_CURRENT_SOURCE_DIR}/icons")
        list (APPEND SOURCES ${RES_FILE})
    else ()
        list (APPEND SOURCES ${RC_FILE})
    endif ()
endif ()

if (APPLE)
    set (ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/icons/${PROJECT_NAME}.icns)
    list (APPEND SOURCES ${ICON_FILE} ${QM_FILES})
    set (MACOSX_BUNDLE_ICON_FILE ${PROJECT_NAME}.icns)
    set_source_files_properties (${ICON_FILE} PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources)
    if (NOT EMBED_TRANSLATIONS)
        set_source_files_properties (${QM_FILES} PROPERTIES
            MACOSX_PACKAGE_LOCATION Resources)
        add_qt_translations(QT_TRANSLATIONS cs es ru)
        set_source_files_properties (${QT_TRANSLATIONS} PROPERTIES
            MACOSX_PACKAGE_LOCATION translations)
        list (APPEND SOURCES ${QT_TRANSLATIONS})
    endif ()
endif ()

message (STATUS "Drumstick MIDI File Player v${PROJECT_VERSION}
     install prefix: ${CMAKE_INSTALL_PREFIX}
     Build configuration: ${CMAKE_BUILD_TYPE}
     Operating System: ${CMAKE_SYSTEM_NAME}
     Processor: ${CMAKE_SYSTEM_PROCESSOR}
     Qt Version: ${QT_VERSION}
     Drumstick Version: ${Drumstick_VERSION}
     Uchardet Version: ${UCHARDET_VERSION}"
)

add_executable ( ${PROJECT_NAME} ${SOURCES} )

target_link_libraries ( ${PROJECT_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::PrintSupport
    Drumstick::File
    Drumstick::RT
    Drumstick::Widgets
    PkgConfig::UCHARDET
)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries( ${PROJECT_NAME} PRIVATE
        Qt6::Core5Compat
    )
endif()

if (WIN32)
    set_target_properties ( ${PROJECT_NAME} PROPERTIES WIN32_EXECUTABLE true )
    target_link_libraries ( ${PROJECT_NAME} PRIVATE winmm dwmapi )
endif ()

if (APPLE)
    set_target_properties ( ${PROJECT_NAME} PROPERTIES
    MACOSX_BUNDLE true
    MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.${PROJECT_NAME}"
    MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME}"
    MACOSX_BUNDLE_DISPLAY_NAME "${PROJECT_NAME}"
    MACOSX_BUNDLE_INFO_STRING "${PROJECT_DESCRIPTION}"
    MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
    MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}"
    MACOSX_BUNDLE_COPYRIGHT "Copyright © 2021, Pedro López-Cabanillas &lt;plcl@users.sf.net&gt;")
    target_link_libraries(${PROJECT_NAME} PRIVATE "-framework CoreFoundation -framework Cocoa")
endif ()

target_compile_definitions( ${PROJECT_NAME} PRIVATE
    VERSION=${PROJECT_VERSION}
    $<$<BOOL:${EMBED_TRANSLATIONS}>:TRANSLATIONS_EMBEDDED>
)
if (DEFINED PROJECT_WC_REVISION)
    target_compile_definitions( ${PROJECT_NAME} PRIVATE
        REVISION=${PROJECT_WC_REVISION} )
endif()

include(GNUInstallDirs)
add_subdirectory(examples)

if(UNIX AND NOT APPLE)
    add_subdirectory(docs)
    add_subdirectory(icons)
    install(TARGETS ${PROJECT_NAME}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES ${QM_FILES}
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME})
    install(FILES "net.sourceforge.dmidiplayer.desktop"
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
    install(FILES "net.sourceforge.dmidiplayer.appdata.xml"
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

    # uninstall target
    if(NOT TARGET uninstall)
      configure_file(
        "${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)
      add_custom_target ( uninstall
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
    endif()
else()
    include(DeploymentUtils)
endif()

=== docs/CMakeLists.txt ===
if(BUILD_DOCS)
    if(NOT EXISTS ${PANDOC_EXECUTABLE})
        find_program(PANDOC_EXECUTABLE pandoc)
        mark_as_advanced(PANDOC_EXECUTABLE)
        if(NOT EXISTS ${PANDOC_EXECUTABLE})
            message(FATAL_ERROR "Pandoc not found. Install Pandoc or set the cache variable PANDOC_EXECUTABLE.")
        endif()
    endif()

    if(EXISTS ${PANDOC_EXECUTABLE})
        macro(add_manpage out_file)
            set(_src  ${CMAKE_CURRENT_SOURCE_DIR}/${out_file}.md)
#           unset(_date)
#           execute_process (
#               COMMAND bash -c "LANG=C;date +'%B %d, %Y'"
#               OUTPUT_VARIABLE _date
#               OUTPUT_STRIP_TRAILING_WHITESPACE
#           )
            set(_date "Jun 29, 2021")
            set(_footer "${PROJECT_NAME} ${PROJECT_VERSION}")
            add_custom_command (
                OUTPUT ${out_file}
                COMMAND ${PANDOC_EXECUTABLE} -s -t man -Vdate=${_date} -Vfooter=${_footer} ${_src} -o ${out_file}
                DEPENDS ${_src}
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                VERBATIM
            )
            add_custom_target(manpages ALL DEPENDS ${out_file})
        endmacro()
        
        add_manpage(dmidiplayer.1)
        
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dmidiplayer.1
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
    endif()
else()
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/dmidiplayer.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

=== examples/CMakeLists.txt ===
file(GLOB MIDI_FILES *.mid)
file(GLOB KAR_FILES *.kar)
install( FILES ${MIDI_FILES} ${KAR_FILES}
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME} )

set(contents "")
foreach(fullfile ${MIDI_FILES};${KAR_FILES})
    get_filename_component(filename ${fullfile} NAME)
    set(contents "${contents}${filename}\n")
endforeach()

set(LST_FILE ${CMAKE_CURRENT_BINARY_DIR}/examples.lst)
file(WRITE ${LST_FILE} ${contents})
install( FILES ${LST_FILE}
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME} )

=== icons/CMakeLists.txt ===
install (FILES ${PROJECT_NAME}_24x24.png
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps
         RENAME ${PROJECT_NAME}.png)

install (FILES ${PROJECT_NAME}_32x32.png
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps
         RENAME ${PROJECT_NAME}.png)

install (FILES ${PROJECT_NAME}_48x48.png
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps
         RENAME ${PROJECT_NAME}.png)

install (FILES ${PROJECT_NAME}_64x64.png
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
         RENAME ${PROJECT_NAME}.png)

install (FILES ${PROJECT_NAME}_128x128.png
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps
         RENAME ${PROJECT_NAME}.png)

install (FILES ${PROJECT_NAME}.svgz
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps )

=== debian/changelog ===
dmidiplayer-dmo (1.4.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 29 Jun 2021 19:19:12 +0200

dmidiplayer-dmo (1.3.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 01 Jun 2021 02:23:31 +0200

dmidiplayer-dmo (1.3.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 12 May 2021 23:13:25 +0200

=== debian/control ===
Source: dmidiplayer-dmo
Section: sound
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://sourceforge.net/projects/dmidiplayer/
Rules-Requires-Root: no
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, qtbase5-dev,
 libuchardet-dev, libdrumstick-dev (>= 1:2.3.0~), qttools5-dev, pkg-config,
 pandoc

Package: dmidiplayer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Featured MIDI File Player.
 Features:
 .
  * MIDI Output to hardware MIDI ports, or any other Drumstick backend.
  * Transpose song tonality between -12 and +12 semitones
  * Change MIDI volume level (using MIDI CC7)
  * Scale song speed between half and double tempo
  * Plays Standard MIDI Files (.MID, .KAR) and Cakewalk project files (.WRK)
  * Views: Rhythm, MIDI Channels, Piano Player, Lyrics (Karaoke)

=== debian/watch ===
version=4

https://github.com/pedrolcl/dmidiplayer/releases \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@

## dmidiplayer-dmo 1.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Drumstick MIDI File Player Multiplatform Program
-# Copyright (C) 2006-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+# Copyright (C) 2006-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,15 +15,15 @@
 # along with this program. If not, see <http://www.gnu.org/licenses/>.
 
 cmake_minimum_required(VERSION 3.14)
-set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")
 
 project ( dmidiplayer
-    VERSION 1.4.0
+    VERSION 1.7.1
     LANGUAGES CXX
     DESCRIPTION "Drumstick MIDI File Player Multiplatform Program"
     HOMEPAGE_URL "https://sourceforge.net/p/dmidiplayer/"
 )
 
+set(PROJECT_RELEASE_DATE "Dec 6, 2022")
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -33,21 +33,30 @@
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
-option(BUILD_DOCS "Build man pages" ON)
+option(BUILD_DOCS "Process Markdown sources of man pages and help files" ON)
 option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
+option(USE_QT "Choose which Qt major version (5 or 6) to prefer. By default uses whatever is found")
 
 include(SCMRevision)
 
-find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
-find_package (Qt${QT_VERSION_MAJOR} COMPONENTS Gui Widgets PrintSupport LinguistTools REQUIRED)
-find_package (Drumstick 2.3 COMPONENTS File RT Widgets REQUIRED)
-
-find_package( PkgConfig )
+if (USE_QT)
+    if (NOT (USE_QT EQUAL 5 OR USE_QT EQUAL 6))
+        message(FATAL_ERROR "Wrong Qt major version. Only 5 and 6 are valid options")
+    endif()
+    find_package(QT NAMES Qt${USE_QT})
+else()
+    find_package(QT NAMES Qt5 Qt6)
+endif()
+
+find_package (Qt${QT_VERSION_MAJOR} 5.15 COMPONENTS Gui Widgets PrintSupport LinguistTools REQUIRED)
+if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
+    find_package (Qt6Core5Compat REQUIRED)
+endif()
+
+find_package (Drumstick 2.7 COMPONENTS File RT Widgets REQUIRED)
+
+find_package ( PkgConfig )
 pkg_check_modules( UCHARDET REQUIRED IMPORTED_TARGET uchardet )
-
-if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
-    find_package(Qt6 COMPONENTS Core5Compat REQUIRED)
-endif()
 
 SET(SOURCES
     channels.cpp
@@ -61,10 +70,18 @@
     guiplayer.h
     guiplayer.qrc
     guiplayer.ui
+    helpwindow.cpp
+    helpwindow.h
+    docs/help.qrc
+    framelesswindow.cpp
+    framelesswindow.h
     iconutils.cpp
     iconutils.h
     instrumentset.cpp
     instrumentset.h
+    loopdialog.cpp
+    loopdialog.h
+    loopdialog.ui
     lyrics.cpp
     lyrics.h
     pianola.cpp
@@ -109,7 +126,11 @@
 
 set ( TRANSLATIONS
    translations/${PROJECT_NAME}_cs.ts
+   translations/${PROJECT_NAME}_de.ts
    translations/${PROJECT_NAME}_es.ts
+   translations/${PROJECT_NAME}_fr.ts
+   translations/${PROJECT_NAME}_gl.ts
+   translations/${PROJECT_NAME}_it.ts
    translations/${PROJECT_NAME}_ru.ts
 )
 
@@ -121,14 +142,27 @@
 add_custom_target (translations ALL DEPENDS ${QM_FILES})
 include(TranslationUtils)
 
+get_target_property(DRUMSTICK_LOCATION Drumstick::Widgets LOCATION)
+get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
+get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_PREFIX} DIRECTORY)
+
+if (EXISTS ${DRUMSTICK_PREFIX}/share/drumstick/)
+    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
+elseif (EXISTS ${DRUMSTICK_PREFIX}/library/widgets/)
+    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/library/widgets/drumstick-widgets_*.qm")
+endif()
+
 if (EMBED_TRANSLATIONS)
-    get_target_property(DRUMSTICK_LOCATION Drumstick::Widgets INTERFACE_INCLUDE_DIRECTORIES)
-    get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
-    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
     file(COPY ${WIDGETS_TRANS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
     add_app_translations_resource(APP_RES ${QM_FILES} ${WIDGETS_TRANS})
-    add_qt_translations_resource(QT_RES cs es ru)
+    add_qt_translations_resource(QT_RES cs de es fr gl it ru)
     list(APPEND SOURCES ${APP_RES} ${QT_RES})
+else()
+    if (APPLE)
+        set_source_files_properties (${WIDGETS_TRANS} PROPERTIES
+            MACOSX_PACKAGE_LOCATION Resources )
+        list (APPEND SOURCES ${WIDGETS_TRANS})
+    endif()
 endif()
 
 if (WIN32)
@@ -149,7 +183,14 @@
     endif ()
 endif ()
 
+include(GNUInstallDirs)
+add_subdirectory(docs)
+add_subdirectory(examples)
+
 if (APPLE)
+    set_source_files_properties (${EXAMPLES} PROPERTIES
+        MACOSX_PACKAGE_LOCATION Resources )
+    list (APPEND SOURCES ${EXAMPLES})
     set (ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/icons/${PROJECT_NAME}.icns)
     list (APPEND SOURCES ${ICON_FILE} ${QM_FILES})
     set (MACOSX_BUNDLE_ICON_FILE ${PROJECT_NAME}.icns)
@@ -158,7 +199,7 @@
     if (NOT EMBED_TRANSLATIONS)
         set_source_files_properties (${QM_FILES} PROPERTIES
             MACOSX_PACKAGE_LOCATION Resources)
-        add_qt_translations(QT_TRANSLATIONS cs es ru)
+        add_qt_translations(QT_TRANSLATIONS cs de es fr gl it ru)
         set_source_files_properties (${QT_TRANSLATIONS} PROPERTIES
             MACOSX_PACKAGE_LOCATION translations)
         list (APPEND SOURCES ${QT_TRANSLATIONS})
@@ -176,6 +217,9 @@
 )
 
 add_executable ( ${PROJECT_NAME} ${SOURCES} )
+if (BUILD_DOCS)
+    add_dependencies ( ${PROJECT_NAME} update_helpfiles )
+endif()
 
 target_link_libraries ( ${PROJECT_NAME} PRIVATE
     Qt${QT_VERSION_MAJOR}::Widgets
@@ -207,7 +251,7 @@
     MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}"
     MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
     MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}"
-    MACOSX_BUNDLE_COPYRIGHT "Copyright © 2021, Pedro López-Cabanillas &lt;plcl@users.sf.net&gt;")
+    MACOSX_BUNDLE_COPYRIGHT "Copyright © 2021-2022, Pedro López-Cabanillas &lt;plcl@users.sf.net&gt;")
     target_link_libraries(${PROJECT_NAME} PRIVATE "-framework CoreFoundation -framework Cocoa")
 endif ()
 
@@ -220,11 +264,7 @@
         REVISION=${PROJECT_WC_REVISION} )
 endif()
 
-include(GNUInstallDirs)
-add_subdirectory(examples)
-
 if(UNIX AND NOT APPLE)
-    add_subdirectory(docs)
     add_subdirectory(icons)
     install(TARGETS ${PROJECT_NAME}
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
@@ -232,7 +272,7 @@
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME})
     install(FILES "net.sourceforge.dmidiplayer.desktop"
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
-    install(FILES "net.sourceforge.dmidiplayer.appdata.xml"
+    install(FILES "net.sourceforge.dmidiplayer.metainfo.xml"
         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
 
     # uninstall target
@@ -244,6 +284,25 @@
       add_custom_target ( uninstall
         COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
     endif()
+
+    find_package(Git)
+    if (Git_FOUND)
+        find_program(GZIP gzip)
+        find_program(BZIP2 bzip2)
+        if ((EXISTS ${GZIP}) AND (EXISTS ${BZIP2}))
+            set(ARCHNAME ${PROJECT_NAME}-${PROJECT_VERSION})
+            add_custom_target ( tarballs
+                COMMAND ${GIT_EXECUTABLE} archive --format=zip --prefix=${ARCHNAME}/ --output ${CMAKE_BINARY_DIR}/${ARCHNAME}.zip master
+                COMMAND ${GIT_EXECUTABLE} archive --format=tar --prefix=${ARCHNAME}/ master | ${GZIP} > ${CMAKE_BINARY_DIR}/${ARCHNAME}.tar.gz
+                COMMAND ${GIT_EXECUTABLE} archive --format=tar --prefix=${ARCHNAME}/ master | ${BZIP2} > ${CMAKE_BINARY_DIR}/${ARCHNAME}.tar.bz2
+                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+                COMMENT "Creating tarballs..."
+                VERBATIM )
+        else()
+            message(WARNING "Missing utilities for tarball creation")
+        endif()
+    endif()
+
 else()
     include(DeploymentUtils)
 endif()

=== debian/changelog ===
dmidiplayer-dmo (1.7.1-dmo2) unstable; urgency=medium

  * Don't regenerate documentation with pandoc.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 01 Mar 2023 08:05:17 +0100

dmidiplayer-dmo (1.7.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 07 Dec 2022 13:30:42 +0100

dmidiplayer-dmo (1.7.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 07 Aug 2022 13:07:31 +0200

dmidiplayer-dmo (1.6.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 16 May 2022 08:47:57 +0200

dmidiplayer-dmo (1.5.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 23 Dec 2021 13:19:44 +0100

dmidiplayer-dmo (1.5.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 25 Oct 2021 10:11:32 +0200

dmidiplayer-dmo (1.5.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 19 Sep 2021 01:16:12 +0200

dmidiplayer-dmo (1.5.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 22 Aug 2021 13:12:59 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://sourceforge.net/projects/dmidiplayer/
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13), cmake, ninja-build, qtbase5-dev,
- libuchardet-dev, libdrumstick-dev (>= 1:2.3.0~), qttools5-dev, pkg-config,
- pandoc
+ libuchardet-dev, libdrumstick-dev (>= 1:2.6.0), qttools5-dev, pkgconf,
+ quilt
 
 Package: dmidiplayer
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_QT=5 \
	-DBUILD_DOCS=OFF

#	exit 1

override_dh_clean:
#	find docs -name index.html -delete

	dh_clean

override_dh_auto_test:

=== debian/watch ===
version=4

https://github.com/pedrolcl/dmidiplayer/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@

## dmidiplayer-dmo 1.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,30 +1,32 @@
-# Drumstick MIDI File Player Multiplatform Program
-# Copyright (C) 2006-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program. If not, see <http://www.gnu.org/licenses/>.
-
-cmake_minimum_required(VERSION 3.14)
+#[==========================================================================[
+Drumstick MIDI File Player Multiplatform Program
+Copyright (C) 2006-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program. If not, see <http://www.gnu.org/licenses/>.
+#]==========================================================================]
+
+cmake_minimum_required(VERSION 3.16)
 
 project ( dmidiplayer
-    VERSION 1.7.1
+    VERSION 1.7.5
     LANGUAGES CXX
     DESCRIPTION "Drumstick MIDI File Player Multiplatform Program"
     HOMEPAGE_URL "https://sourceforge.net/p/dmidiplayer/"
 )
 
-set(PROJECT_RELEASE_DATE "Dec 6, 2022")
-set(CMAKE_CXX_STANDARD 11)
+set(PROJECT_RELEASE_DATE "December 30, 2024")
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
@@ -35,28 +37,30 @@
 
 option(BUILD_DOCS "Process Markdown sources of man pages and help files" ON)
 option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
-option(USE_QT "Choose which Qt major version (5 or 6) to prefer. By default uses whatever is found")
+option(USE_QT5 "Choose to build with Qt5 instead of Qt6" OFF)
+
+# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
+# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2024/12
+if(MSVC)
+    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
+endif()
 
 include(SCMRevision)
 
-if (USE_QT)
-    if (NOT (USE_QT EQUAL 5 OR USE_QT EQUAL 6))
-        message(FATAL_ERROR "Wrong Qt major version. Only 5 and 6 are valid options")
-    endif()
-    find_package(QT NAMES Qt${USE_QT})
-else()
-    find_package(QT NAMES Qt5 Qt6)
-endif()
-
-find_package (Qt${QT_VERSION_MAJOR} 5.15 COMPONENTS Gui Widgets PrintSupport LinguistTools REQUIRED)
-if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
-    find_package (Qt6Core5Compat REQUIRED)
-endif()
-
-find_package (Drumstick 2.7 COMPONENTS File RT Widgets REQUIRED)
-
-find_package ( PkgConfig )
-pkg_check_modules( UCHARDET REQUIRED IMPORTED_TARGET uchardet )
+if (USE_QT5)
+    find_package( QT NAMES Qt5 REQUIRED)
+else()
+    find_package( QT NAMES Qt6 REQUIRED)
+endif()
+
+if(QT_VERSION VERSION_LESS 6.0.0)
+    find_package ( Qt5 5.15 COMPONENTS Gui Widgets PrintSupport LinguistTools REQUIRED )
+else()
+    find_package ( Qt6 6.2 COMPONENTS Gui Widgets PrintSupport LinguistTools Core5Compat REQUIRED )
+endif()
+
+find_package ( Drumstick 2.10 COMPONENTS File RT Widgets REQUIRED )
+find_package ( uchardet 0.0.8 COMPONENTS libuchardet REQUIRED )
 
 SET(SOURCES
     channels.cpp
@@ -146,6 +150,10 @@
 get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
 get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_PREFIX} DIRECTORY)
 
+get_target_property(UCHARDET_LOCATION uchardet::libuchardet LOCATION)
+get_filename_component(UCHARDET_PREFIX ${UCHARDET_LOCATION} DIRECTORY)
+get_filename_component(UCHARDET_PREFIX ${UCHARDET_PREFIX} DIRECTORY)
+
 if (EXISTS ${DRUMSTICK_PREFIX}/share/drumstick/)
     file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
 elseif (EXISTS ${DRUMSTICK_PREFIX}/library/widgets/)
@@ -166,8 +174,11 @@
 endif()
 
 if (WIN32)
+    include (InstallRequiredSystemLibraries)
+    install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}
+             DESTINATION .)
     set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
-    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.nsi.in
+    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}_msvc.nsi.in
         ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.nsi IMMEDIATE @ONLY)
     configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc.in
         ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc IMMEDIATE @ONLY)
@@ -213,7 +224,7 @@
      Processor: ${CMAKE_SYSTEM_PROCESSOR}
      Qt Version: ${QT_VERSION}
      Drumstick Version: ${Drumstick_VERSION}
-     Uchardet Version: ${UCHARDET_VERSION}"
+     Uchardet Version: ${uchardet_VERSION}"
 )
 
 add_executable ( ${PROJECT_NAME} ${SOURCES} )
@@ -227,7 +238,7 @@
     Drumstick::File
     Drumstick::RT
     Drumstick::Widgets
-    PkgConfig::UCHARDET
+    uchardet::libuchardet
 )
 
 if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
@@ -251,7 +262,7 @@
     MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}"
     MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
     MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}"
-    MACOSX_BUNDLE_COPYRIGHT "Copyright © 2021-2022, Pedro López-Cabanillas &lt;plcl@users.sf.net&gt;")
+    MACOSX_BUNDLE_COPYRIGHT "Copyright © 2021-2024, Pedro López-Cabanillas &lt;plcl@users.sf.net&gt;")
     target_link_libraries(${PROJECT_NAME} PRIVATE "-framework CoreFoundation -framework Cocoa")
 endif ()

=== docs/CMakeLists.txt ===
set(MANPAGE ${PROJECT_NAME}.1)
if (BUILD_DOCS)
    include(PandocMacros)
    if (UNIX AND NOT APPLE)
        add_manpage(${MANPAGE})
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
    endif()
    update_helpfiles(cs de en es fr gl it ru)
else()
    if (UNIX AND NOT APPLE)
        install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
    endif()
endif()

=== examples/CMakeLists.txt ===
file(GLOB KAR_FILES *.kar)
file(GLOB MIDI_FILES *.mid)

set(contents "")
foreach(fullfile ${KAR_FILES};${MIDI_FILES})
    get_filename_component(filename ${fullfile} NAME)
    set(contents "${contents}${filename}\n")
endforeach()

set(LST_FILE ${CMAKE_CURRENT_BINARY_DIR}/examples.lst)
file(WRITE ${LST_FILE} ${contents})

if (APPLE)
    set (EXAMPLES ${LST_FILE};${MIDI_FILES};${KAR_FILES} PARENT_SCOPE)
else()
    install( FILES ${MIDI_FILES} ${KAR_FILES}  ${LST_FILE}
             DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME} )
endif()

=== debian/changelog ===
dmidiplayer-dmo (1.7.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 30 Dec 2024 15:02:01 +0100

dmidiplayer-dmo (1.7.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 31 Aug 2024 15:24:55 +0200

dmidiplayer-dmo (1.7.3-dmo3) unstable; urgency=medium

  * Build with Qt6 6.6

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 07 Jun 2024 07:59:10 +0200

dmidiplayer-dmo (1.7.3-dmo2) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 Mar 2024 09:35:42 +0100

dmidiplayer-dmo (1.7.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 12 Oct 2023 08:43:51 +0200

dmidiplayer-dmo (1.7.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 09 Jul 2023 08:51:48 +0200

dmidiplayer-dmo (1.7.1-dmo3) unstable; urgency=medium

  * Build with Qt6

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 12 Jun 2023 16:09:59 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://sourceforge.net/projects/dmidiplayer/
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
-Build-Depends: debhelper-compat (= 13), cmake, ninja-build, qtbase5-dev,
- libuchardet-dev, libdrumstick-dev (>= 1:2.6.0), qttools5-dev, pkgconf,
- quilt
+Standards-Version: 4.7.0
+Build-Depends: debhelper-compat (= 13), cmake (>= 3.16), ninja-build, pkgconf,
+ libuchardet-dev (>= 0.0.8), libdrumstick-dev (>= 1:2.10~), qt6-base-dev,
+ qt6-tools-dev, qt6-5compat-dev
 
 Package: dmidiplayer
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DBUILD_DOCS=OFF

#	exit 1

# No tests and ninja fail
override_dh_auto_test:
